<?php

namespace App\DataTables;

use App\Models\Prenotazione;
use Illuminate\Database\Eloquent\Model;
use Illuminate\Validation\Rule;
use Yajra\DataTables\DataTablesEditor;
use Illuminate\Http\Request;
use Illuminate\Validation\ValidationException;
use Storage;
use Illuminate\Support\Str;

class PrenotazioneDataTableEditor extends DataTablesEditor
{
  protected $model = Prenotazione::class;
  // protected $uploadDir = '';
  // protected $disk = 'modelliRicevute';

  protected $messages = [
    'nome.required' => 'Il nome è richiesto',
    'cognome.required' => 'Il cognome è richiesto',
    'email.required' => 'L\'email è richiesta',
    'telefono.required' => 'Il telefono è richiesto',
    'evento_id.required' => 'L\'evento è richiesto',
    'cucina_id.required' => 'La cucina è richiesta',
    'stato.required' => 'Il stato è richiesto',
    'note.required' => 'La note è richiesta',
  ];

  /**
  * Get create action validation rules.
  *
  * @return array
  */
  public function createRules(): array
  {
    return [
      'nome'  => 'required',
      'cognome' => 'required',
      'email' => 'nullable|email',
      'telefono' => 'nullable',
      'evento_id' => 'required|exists:evento,id',
      'cucina_id' => 'required|exists:cucina,id',
      'stato' => 'nullable|string',
      'note' => 'nullable',
      'codice' => 'required|unique:prenotazione,codice',
      'stato_pagamento' => 'nullable|string',
      'metodo_pagamento' => 'nullable|string',
    ];
  }

  public function createMessages(): array{
    return $this->messages;
  }

  /**
  * Get edit action validation rules.
  *
  * @param Model $model
  * @return array
  */
  public function editRules(Model $model): array
  {
    return [
      'nome'  => 'required',
      'cognome' => 'required',
      'email' => 'nullable|email',
      'telefono' => 'nullable',
      'evento_id' => 'required|exists:evento,id',
      'cucina_id' => 'required|exists:cucina,id',
      'stato' => 'nullable|string',
      'note' => 'nullable',
      'codice' => 'required|unique:prenotazione,codice',
    ];
  }

  public function editMessages(): array{
    return $this->messages;
  }

  /**
  * Get remove action validation rules.
  *
  * @param Model $model
  * @return array
  */
  public function removeRules(Model $model): array
  {
    return [];
  }

  public function creating(Model $model, array $data): array
  {
    // $model->roles()->sync([$data['ruolo_id']]);
    return $data;
  }

  public function updating(Model $model, array $data): array
  {
    // dd($data['ruolo']);
    // $model->roles()->sync([$data['ruolo_id']]);
    return $data;
  }
  public function messages(): array
  {
    return $this->messages;
  }

}
